function data_write(frequency,Vgrid,sb_location)

%% Dss file

load('Network Data.mat');

Line(18,2) = sb_location;

[fid, message] =  fopen([pwd,'\Examined_Network.dss'], 'wt');

fprintf(fid,'\nclear\n');
fprintf(fid,['set DefaultBaseFrequency=',num2str(frequency),'\n']);


fprintf(fid,['\nnew circuit.name bus1=',Busname{SW(1)},' baseKv=',num2str(Vgrid,10),' angle=0 frequency=',num2str(frequency),' phases=3 MVAsc1=',num2str(SW(5)),' MVAsc3=',num2str(SW(4)),' x1r1=',num2str(SW(6)),' x0r0=',num2str(SW(7)),'\n']);
fprintf(fid,'\n');

[rows,~]=size(Line);

for i=1:rows
            name=Linename{i};
            values=Line(i,:);
            Rph=num2str(values(6),10);
            Xph=num2str(values(7)*frequency/50,10);
            Rn=num2str((values(9)-values(6))/3,10);
            Xn=num2str(((values(10)-values(7))/3)*frequency/50,10);
            Cph=num2str(values(8)*10^(-9),10);
            %         Cn                          
            Cn=num2str((values(11)*10^(-9)-values(8)*10^(-9))/3);
            fprintf(fid,['new line.',name,' bus1=',Busname{values(1)},'.1.2.3.4 bus2=',Busname{values(2)},'.1.2.3.4 length=',...
            num2str(values(4)),' phases=4 units=km rmatrix=[',Rph,' | 0 ',Rph,' | 0 0 ',Rph,' | 0 0 0 ',Rn,' ] xmatrix=[',Xph,' |  0 ',Xph,' | 0 0 ',...
            Xph,' | 0 0 0 ',Xn,'] cmatrix=[',Cph,' | 0 ',Cph,' | 0 0 ',Cph,' | 0 0 0 ',Cn,' ] Rg=0 Xg=0\n']);
end

[rows,~]=size(Gen);
fprintf(fid,'\n!!Generation\n');
for i=1:rows
    values=Gen(i,:);
    Generation(fid,values,cell2mat(Genname(i)),Busname,phase_con) ;
    fprintf(fid,'\n');
end

[rows,~]=size(PQLoad);
fprintf(fid,'\n!!Loads\n');
for i=1:rows
    values=PQLoad(i,:);
    PQLoad_f(fid,values,cell2mat(PQLoadname(i)),Busname,phase_con) ;
    fprintf(fid,'\n');
end

% [rows,~]=size(ZIP);
% fprintf(fid,'\n!ZIP Loads\n');   
% for i = 1:rows
%     values=ZIP(i,:);
%     ZIP_F(fid,values,cell2mat(ZIPname(i)),Busname,phase_con,frequency) ;
%     fprintf(fid,'\n');
% end

fprintf(fid,'\n!Reactors\n');
[rows,~]=size(Bus);
for i=1:rows
    values=Bus(i,:);
    Reactors(fid,values,Busname) ;     
end
fprintf(fid,'\n');

fprintf(fid,'set Algorithm=Normal\n');
fprintf(fid,['set maxiterations=',num2str(150),'\n']);
fprintf(fid,['set tolerance=',num2str(0.0001)]);

% closing data file
fclose(fid);

end

%% Auxiliary Functions

function PQLoad_f(fid,PQLoad,name,Busname,connection)

switch PQLoad(4)
    
    case 1
    P=PQLoad(5);
    Q=PQLoad(6);
    case 3
    P=PQLoad(7);
    Q=tan(acos(PQLoad(8)))*P;   
    case 4
    P=PQLoad(9)*abs(PQLoad(10));
    Q=sign(PQLoad(10))*sqrt(PQLoad(9)^2-P^2);
end

if PQLoad(11)==1
    Vmax=PQLoad(12);
    Vmin=PQLoad(13);
else
    Vmax=2;
    Vmin=0.1;
end
con=cell2mat(connection(PQLoad(3)));

                [rows,~]=size(con);
                if rows==3
                   fprintf(fid,['new load.',name,'a',' bus1=',Busname{PQLoad(1)},'.',con(1,:),' phases=1 kV=(',num2str(PQLoad(2)),' 3 sqrt /) kw=',num2str(P/3,10),...
                   ' kvar=',num2str(Q/3,10),' model=1 status=fixed Vminpu=',num2str(Vmin),' Vmaxpu=',num2str(Vmax),' \n']);
                   fprintf(fid,['new load.',name,'b',' bus1=',Busname{PQLoad(1)},'.',con(2,:),' phases=1 kV=(',num2str(PQLoad(2)),' 3 sqrt /) kw=',num2str(P/3,10),...
                   ' kvar=',num2str(Q/3,10),' model=1 status=fixed Vminpu=',num2str(Vmin),' Vmaxpu=',num2str(Vmax),' \n']);
                   fprintf(fid,['new load.',name,'c',' bus1=',Busname{PQLoad(1)},'.',con(3,:),' phases=1 kV=(',num2str(PQLoad(2)),' 3 sqrt /) kw=',num2str(P/3,10),...
                   ' kvar=',num2str(Q/3,10),' model=1 status=fixed Vminpu=',num2str(Vmin),' Vmaxpu=',num2str(Vmax),' \n']);

                else
                   fprintf(fid,['new load.',name,' bus1=',Busname{PQLoad(1)},'.',con,' phases=1 kV=(',num2str(PQLoad(2)),' 3 sqrt /) kw=',num2str(P,10),...
                   ' kvar=',num2str(Q,10),' model=1 status=fixed Vminpu=',num2str(Vmin),' Vmaxpu=',num2str(Vmax),' \n']);
  
                end


end

function Generation(fid,Gen,name,Busname,connection)

% switch Gen(6)
%     case 1
%     P=Gen(9);
%     Q=Gen(10);
%     case 3
%     P=Gen(7);
%     Q=tan(acos(Gen(8)))*P;
% end
P=0;
Q=0;

con=cell2mat(connection(Gen(2)));

                [rows,~]=size(con);
                if rows==3
                   fprintf(fid,['new generator.',name,'a',' bus1=',Busname{Gen(1)},'.',con(1,:),' phases=1 kV=(',num2str(Gen(3)),' 3 sqrt /) kw=',num2str(P/3,10),...
                   ' kvar=',num2str(Q/3,10),' model=1 Vminpu=0.1 Vmaxpu=2 \n']);
                   fprintf(fid,['new generator.',name,'b',' bus1=',Busname{Gen(1)},'.',con(2,:),' phases=1 kV=(',num2str(Gen(3)),' 3 sqrt /) kw=',num2str(P/3,10),...
                   ' kvar=',num2str(Q/3,10),' model=1 Vminpu=0.1 Vmaxpu=2 \n']);
                   fprintf(fid,['new generator.',name,'c',' bus1=',Busname{Gen(1)},'.',con(3,:),' phases=1 kV=(',num2str(Gen(3)),' 3 sqrt /) kw=',num2str(P/3,10),...
                   ' kvar=',num2str(Q/3,10),' model=1 Vminpu=0.1 Vmaxpu=2 \n']);

                else
                   fprintf(fid,['new generator.',name,' bus1=',Busname{Gen(1)},'.',con,' phases=1 kV=(',num2str(Gen(3)),' 3 sqrt /) kw=',num2str(P,10),...
                   ' kvar=',num2str(Q,10),' model=1 Vmin=0.1 Vmax=2 \n']);
  
                end



end

function ZIP_F(fid,ZIP,name,Busname,connection,frequency)

P=ZIP(4);
Q=ZIP(5);

Snomfreq=1000*(P+1i*Q);

Zf=real((ZIP(3)*1000)^2/(Snomfreq'))+1i*(frequency/50)*imag((ZIP(3)*1000)^2/(Snomfreq'));

P=real((ZIP(3)*1000)^2/(Zf'))/1000;
Q=imag((ZIP(3)*1000)^2/(Zf'))/1000;

Pz=ZIP(6);
Pi=ZIP(7);
Pp=ZIP(8);
Qz=ZIP(9);
Qi=ZIP(10);
Qq=ZIP(11);



cutoffvoltage=0;
con=cell2mat(connection(ZIP(2)));

                [rows,~]=size(con);
                if rows==3
                   fprintf(fid,['new load.',name,'a',' bus1=',Busname{ZIP(1)},'.',con(1,:),' phases=1 kV=(',num2str(ZIP(3)),' 3 sqrt /) kw=',num2str(P/3,10),...
                   ' kvar=',num2str(Q/3,10),' model=8 conn=wye status=fixed Vminpu=0.01 Vmaxpu=2 ZIPV=[',num2str(Pz/100),' ',num2str(Pi/100),' ',...
                   num2str(Pp/100),' ',num2str(Qz/100),' ',num2str(Qi/100),' ',num2str(Qq/100),' ',num2str(cutoffvoltage),'] \n']);
                   
                   fprintf(fid,['new load.',name,'b',' bus1=',Busname{ZIP(1)},'.',con(2,:),' phases=1 kV=(',num2str(ZIP(3)),' 3 sqrt /) kw=',num2str(P/3,10),...
                   ' kvar=',num2str(Q/3,10),' model=8 conn=wye status=fixed Vminpu=0.01 Vmaxpu=2 ZIPV=[',num2str(Pz/100),' ',num2str(Pi/100),' ',...
                   num2str(Pp/100),' ',num2str(Qz/100),' ',num2str(Qi/100),' ',num2str(Qq/100),' ',num2str(cutoffvoltage),'] \n']);
                   
                   fprintf(fid,['new load.',name,'c',' bus1=',Busname{ZIP(1)},'.',con(3,:),' phases=1 kV=(',num2str(ZIP(3)),' 3 sqrt /) kw=',num2str(P/3,10),...
                   ' kvar=',num2str(Q/3,10),' model=8 conn=wye status=fixed Vminpu=0.01 Vmaxpu=2 ZIPV=[',num2str(Pz/100),' ',num2str(Pi/100),' ',...
                   num2str(Pp/100),' ',num2str(Qz/100),' ',num2str(Qi/100),' ',num2str(Qq/100),' ',num2str(cutoffvoltage),'] \n']);


                else
                   fprintf(fid,['new load.',name,' bus1=',Busname{ZIP(1)},'.',con,' phases=1 kV=(',num2str(ZIP(3)),' 3 sqrt /) kw=',num2str(P,10),...
                   ' kvar=',num2str(Q,10),' model=8 conn=wye status=fixed Vminpu=0.01 Vmaxpu=2 ZIPV=[',num2str(Pz/100),' ',num2str(Pi/100),' ',...
                   num2str(Pp/100),' ',num2str(Qz/100),' ',num2str(Qi/100),' ',num2str(Qq/100),' ',num2str(cutoffvoltage),'] \n']);

                end

end

function Reactors(fid,Bus,Busname)
       if Bus(3)==1
           fprintf(fid,['new Reactor.reac',Busname{Bus(1)},' phases=1 bus=',Busname{Bus(1)},'.4 R=',num2str(Bus(4)),' X=',num2str(Bus(5)),' \n']);
       end
end




